import { HttpClient } from '@wix/sdk-types';
import { StartOptions, StartResponse, StartResponseNonNullableFields, StateMachineResponse, StateMachineResponseNonNullableFields, VerifyDuringAuthenticationOptions } from './iam-verification-v1-start-response-verification.universal.js';
export declare const __metadata: {
    PACKAGE_NAME: string;
};
export declare function start(httpClient: HttpClient): StartSignature;
interface StartSignature {
    /**
     * starts a verification process
     * example: sends a code to the identity's email
     */
    (options?: StartOptions | undefined): Promise<StartResponse & StartResponseNonNullableFields>;
}
export declare function verifyDuringAuthentication(httpClient: HttpClient): VerifyDuringAuthenticationSignature;
interface VerifyDuringAuthenticationSignature {
    /**
     * Continues the registration process when a member is required to verify an email address
     * using a verification code received by email.
     *
     * Email verification is required when the registering member is already listed as a contact.
     *
     * Typically, after a successful verification, you generate and use member tokens for the
     * registered member so that subsequent API calls are called as part of a member session.
     * @param - The code to verify.
     */
    (code: string, options: VerifyDuringAuthenticationOptions): Promise<StateMachineResponse & StateMachineResponseNonNullableFields>;
}
export declare function resendDuringAuthentication(httpClient: HttpClient): ResendDuringAuthenticationSignature;
interface ResendDuringAuthenticationSignature {
    /**
     * Resend the verification email and continue the registration process when a member is required to verify an email address
     * using a verification code received by email.
     * @param - A state token representing the `REQUIRE_EMAIL_VERIFICATION` state.
     */
    (stateToken: string): Promise<StateMachineResponse & StateMachineResponseNonNullableFields>;
}
export { Address, AddressTag, AddressWrapper, AuthenticatorConnection, Connection, ConnectionTypeOneOf, CustomField, CustomValue, CustomValueValueOneOf, Email, EmailTag, Factor, FactorType, Identity, IdentityProfile, IdpConnection, ListValue, MapValue, Metadata, MfaChallengeData, Phone, PhoneTag, PrivacyStatus, PushChallengeData, Reason, RequireMfaData, ResendDuringAuthenticationRequest, SecondaryEmail, StartOptions, StartRequest, StartResponse, StartResponseNonNullableFields, StateMachineResponse, StateMachineResponseNonNullableFields, StateMachineResponseStateDataOneOf, StateType, Status, StatusName, StatusV2, Target, V1CustomValue, V1CustomValueValueOneOf, V1Factor, V1ListValue, V1MapValue, VerificationChallenge, VerificationChallengeFactorChallengeDataOneOf, VerifyDuringAuthenticationOptions, VerifyDuringAuthenticationRequest, VerifyRequest, VerifyResponse, } from './iam-verification-v1-start-response-verification.universal.js';
