import { RequestOptionsFactory } from '@wix/sdk-types';
/**
 * starts a verification process
 * example: sends a code to the identity's email
 */
export declare function start(payload: object): RequestOptionsFactory<any>;
/**
 * Continues the registration process when a member is required to verify an email address
 * using a verification code received by email.
 *
 * Email verification is required when the registering member is already listed as a contact.
 *
 * Typically, after a successful verification, you generate and use member tokens for the
 * registered member so that subsequent API calls are called as part of a member session.
 */
export declare function verifyDuringAuthentication(payload: object): RequestOptionsFactory<any>;
/**
 * Resend the verification email and continue the registration process when a member is required to verify an email address
 * using a verification code received by email.
 */
export declare function resendDuringAuthentication(payload: object): RequestOptionsFactory<any>;
